<!---
CF_ENVELOPE
by Keith Gaughan <kmgaughan@eircom.net>

Finds the appropriate header and footer files and envelopes the content
in them.

Copyright (c) Keith Gaughan, 2003.
This software is free; you can redistribute it and/or modify it
under the terms of the Design Science License (DSL). If you didn't
receive a copy of the DSL with this software, one can be obtained
at http://www.dsl.org/copyleft/dsl.txt

Notes:

 * The names of the header and footer files are 'header.cfm' and
   'footer.cfm'.
 * It keeps recursing up the directory tree and uses the first of each
   it finds.
--->
<cfif GetCurrentTemplatePath() EQ GetBaseTemplatePath()><cfabort></cfif>
<cfif THISTAG.ExecutionMode EQ "end">
	<cfinclude template="_pvt/global.cfm">

	<cfset basePath = APPLICATION.basePath>
	<cf_quip variable="tagline"
		file="#GetDirectoryFromPath(GetCurrentTemplatePath())#/../quips.txt">

	<cfquery datasource="#APPLICATION.DSN#" name="navigation"
		cachedwithin="#CreateTimeSpan(0, 0, 1, 0)#">
	SELECT	section, CONCAT("#APPLICATION.localPath#", path) AS path
	FROM	navigation
	</cfquery>
	<cfparam name="ATTRIBUTES.section" default="">
	<cfset crntSection = ATTRIBUTES.section>

	<cfparam name="ATTRIBUTES.title" default="" type="string">
	<cfhtmlhead text="<title>#CleanTitle(ATTRIBUTES.title, "talideon.com")#</title>">
	<cfset title   = ATTRIBUTES.title>
	<cfset content = THISTAG.GeneratedContent>
	<cfparam name="ATTRIBUTES.showTitle" type="boolean" default="Yes">
	<cfif ATTRIBUTES.showTitle And ATTRIBUTES.title NEQ "">
		<cfset content = "<h2>#title#</h2>#content#">
	</cfif>

	<cfparam name="ATTRIBUTES.hasComments" type="boolean" default="No">
	<cfif ATTRIBUTES.hasComments>
		<!--- Stop spammers from profiting from comment spam. --->
		<cfhtmlhead text="<!-- Kiss my ass, spammonkeys! -->">
		<cfhtmlhead text="<meta name=""ROBOTS"" content=""INDEX,NOFOLLOW"" />">
		<cfsavecontent variable="comments">
		<cfinclude template="comments.cfm">
		</cfsavecontent>
		<cfset content = content & comments>
	</cfif>

	<cfparam name="ATTRIBUTES.sidebar" default="">
	<cfset sidebar = ATTRIBUTES.sidebar>

	<cfset processingTime = GetTickCount() - REQUEST.startTime>
	<cfcontent type="text/html; charset=ISO-8859-1"><cfinclude template="../skins/niue2.cfm">
</cfif>