<cfscript>
function CleanEntryName(nm) {
	nm = Replace(Trim(REReplace(nm, "[^A-Za-z0-9]+", " ", "ALL")), " ", "-", "ALL");

	// Prevent a numeric name clashing with dates.
	if (IsNumeric(nm)) {
		nm = "x#nm#";
	}

	return nm;
}
</cfscript>
<cfif SESSION.isLoggedIn>
	<cftry>
		<!--- Clean up the entry id --->
		<cfset FORM.nm = CleanEntryName(FORM.nm)>
		<cfif FORM.nm EQ "">
			<!--- No supplied entry name: try using title --->
			<cfset FORM.nm = Left(CleanEntryName(FORM.title), 32)>
			<cfif FORM.nm EQ "">
				<!--- Still not good: use the current date :-( --->
				<cfset FORM.nm = "x" & DateFormat(Now(), "yyyymmdd") & TimeFormat(Now(), "HHmmss")>
			</cfif>
		</cfif>

		<cfset formattedBody = FORM.body>
		<cf_do do="format" variable="formattedBody" imagesPath="#APPLICATION.basePath#/images/">

		<cfquery datasource="#APPLICATION.DSN#" name="update">
		INSERT INTO entries (entry_id, date_posted, title, unformatted_body, body)
		VALUES (
			<cfqueryparam value="#FORM.nm#"       cfsqltype="CF_SQL_VARCHAR">,
			Now(),
			<cfqueryparam value="#FORM.title#"    cfsqltype="CF_SQL_VARCHAR">,
			<cfqueryparam value="#FORM.body#"     cfsqltype="CF_SQL_VARCHAR">,
			<cfqueryparam value="#formattedBody#" cfsqltype="CF_SQL_VARCHAR">
		)
		</cfquery>

		<cfset basePath = GetDirectoryFromPath(GetCurrentTemplatePath())>

		<!--- Ensure year directory, and index --->
		<cfset path = basePath & DateFormat(Now(), "yyyy")>
		<cfif Not DirectoryExists(path)>
			<cfdirectory action="CREATE" directory="#path#">
			<cffile action="WRITE" file="#path#/index.cfm" output="<cfinclude template=""../index.cfm"">">
		</cfif>

		<!--- Ensure month directory, index, and create entry page --->
		<cfset path = basePath & DateFormat(Now(), "yyyy/mm")>
		<cfif Not DirectoryExists(path)>
			<cfdirectory action="CREATE" directory="#path#">
			<cffile action="WRITE" file="#path#/index.cfm" output="<cfinclude template=""../../index.cfm"">">
		</cfif>
		<cffile action="WRITE" file="#path#/#FORM.nm#.cfm" output="<cfinclude template=""../../index.cfm"">">

		<!--- Ensure day page --->
		<cfset path = basePath & DateFormat(Now(), "yyyy/mm/dd") & ".cfm">
		<cfif Not FileExists(path)>
			<cffile action="WRITE" file="#path#" output="<cfinclude template=""../../index.cfm"">">
		</cfif>

		<cfset view = "frontpage">

		<cfmodule template="syndication.cfm">
		<cfcatch type="Database">
			<cfset error = "Could not post entry.">
		</cfcatch>
	</cftry>

	<cftry>
		<!--- Ping Ping-o-Matic on the update. --->
		<cf_do do="pingomatic" title="#settings.name#" blogurl="http://#CGI.SERVER_NAME##APPLICATION.basePath#/weblog/">
		<cfcatch type="Any">
			<cfset error = "Could not ping pingomatic: request timed out.">
		</cfcatch>
	</cftry>
</cfif>
