<!---
edit.cfm
by Keith Gaughan <kmgaughan@eircom.net>

Allows modification of the edit copy.

Copyright (c) Keith Gaughan, 2004.
--->

<cfparam name="doc"    type="string">
<cfparam name="action" type="string" default="Edit">

<cfset saneDoc = REReplace(doc, "[^[:alpha:]-]", "", "all")>
<cfset path    = APPLICATION.pagePath & saneDoc>

<cfswitch expression="#action#">
    <cfcase value="Edit">
        <cf_loadpage files="#path#.edit;#path#.txt">
        <cf_loadpage files="#APPLICATION.pagePath#TextFormattingRules.txt"
            bodyVariable="formatting">

        <cf_format variable="formatting" wikiword="">
        <cf_envelope title="Edit #doc#" doc="#saneDoc#">
        <cfinclude template="./templates/edit.cfm">
        <cfoutput>#formatting#</cfoutput>
        </cf_envelope>
    </cfcase>

    <cfcase value="Revert">
        <cfif FileExists("#path#.edit")>
            <cffile action="DELETE" file="#path#.edit">
        </cfif>
        <cflocation url="./?doc=#doc#&mode=edit">
    </cfcase>

    <cfcase value="Save">
        <cflock timeout="10" name="edit:#saneDoc#" type="exclusive">
            <cffile action="WRITE" file="#path#.edit" output="#FORM.body#"
                addnewline="No">
        </cflock>
        <cfset logFile = ExpandPath("updates.log")>
        <cffile action="APPEND" file="#logFile#"
            output="#CGI.REMOTE_ADDR#,#Now()#,#saneDoc#">
        <cflocation url="./?doc=#doc#&mode=edit">
    </cfcase>

    <cfcase value="Preview">
        <cfset formatted = body>
        <cf_loadpage files="#APPLICATION.pagePath#TextFormattingRules.txt"
            bodyVariable="formatting">
        <cf_format variable="formatted" wikiwords="">
        <cf_format variable="formatting" wikiwords="">

        <cf_envelope title="Edit #doc# (Previewing)" doc="#saneDoc#" isEditCopy="No">
        <cfoutput>#formatted#</cfoutput><hr/>
        <cfinclude template="./templates/edit.cfm">
        <cfoutput>#formatting#</cfoutput>
        </cf_envelope>
    </cfcase>

    <cfdefaultcase>
        <p>WTF!?</p>
    </cfdefaultcase>
</cfswitch>
