<!---
index.cfm
by Keith Gaughan <kmgaughan@eircom.net>

Dispatcher for KWiki.

Copyright (c) Keith Gaughan, 2004.
--->

<cfset PAGE_PATH    = ExpandPath("pages\")>
<cfset LOG_FILE     = ExpandPath("updates.log")>
<cfinclude template="settings.cfm">

<!--- Some session variables that should always be set up. --->
<cfparam name="SESSION.showStable" type="boolean" default="Yes">
<cfset SESSION.isBanned = FALSE>
<cfif Not IsDefined("SESSION.isBanned")>
	<!--- Look up this user's IP on the banned list. --->
	<cf_isbannedip DSN="this-is-the-application-dsn" ip="#CGI.REMOTE_ADDR#" flag="SESSION.isBanned">
	<cfset SESSION.showStable = TRUE>
</cfif>

<cfparam name="doc" type="string" default="#DEFAULT_PAGE#">
<cfparam name="action" type="variableName" default="view">
<cfif action EQ "view">
	<cfparam name="mode" type="string" default="stable">
</cfif>

<!--- Map any pseudopages to actions. --->
<cfif action EQ "view">
	<cfif doc EQ "RecentChanges">
		<cfset action = "recent">
	<cfelseif doc EQ "PageIndex">
		<cfset action = "pagelist">
	</cfif>
</cfif>

<!--- Use the copy in the REQUEST scope: templates invoked with CFMODULE are
      able to directly modify the action this way. --->
<cfset REQUEST.action = action>

<!--- Process the incoming request, if possible --->
<cfif FileExists(ExpandPath("handlers/act_#REQUEST.action#.cfm"))>
	<cfinclude template="handlers/act_#REQUEST.action#.cfm">
</cfif>

<cfinclude template="handlers/dsp_#REQUEST.action#.cfm">
